(*
========================================================
  ҥ~Bzùs JPG 

  @̡GH(ߦѤj) fatcat99@ms5.hinet.net

  G1999/10/20

  qЧ
========================================================

\G

  bҥ~oͮɡANùӬۦs

ΪkG

  N ESShot KbD FORM W

ݩʻG

  Property Active: Boolean;           O_dIҥ~Tùsɪʧ@C

kG

  procedure DeleteErrorScreen(Count: integer);   RùsɡACount OdӼơC
*)

unit ESShot;

interface

uses SysUtils, Jpeg, FileCtrl, Classes, Controls, Windows, Forms,
  Graphics, Dialogs, Messages, stdctrls;

type
  TESShot = class(TComponent)
  private
    FActive: Boolean;
    FOldOnException: TExceptionEvent;
    procedure init;
    procedure SetActive(value: Boolean);
    procedure HandleException(Sender: TObject; E: Exception);
    procedure SaveErrorMessage(FormName, ControlName, Msg: string);
    procedure SaveErrorScreen(Sender: TObject; var Done: Boolean);
    function StrTran(s1, s2, s3: string): string;
  protected
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create(aComponent: TComponent); override;
    destructor Destroy; override;
  published
    property Active: Boolean read FActive write SetActive;
    procedure DeleteErrorScreen(Count: Integer);
  end;


procedure Register;

var
  sNow: string;
  bGotData: Boolean;

implementation

procedure Register;
begin
  RegisterComponents('Neo Yang', [TESShot]);
end;

constructor TESShot.Create(aComponent: TComponent);
begin
  if aComponent = nil then
    raise Exception.Create('Owner cannot be nil!');
  inherited Create(aComponent);
  FActive := True;
  FOldOnException := nil;
  init;
end;

destructor TESShot.Destroy;
begin
  Application.OnException := FOldOnException;
  FOldOnException := nil;
  inherited Destroy;
end;

procedure TESShot.init;
var
  Method1: TMethod;
begin
  if csDesigning in TComponent(Owner).ComponentState then
    Exit;

  if FActive then
  begin
    Method1.Data := Self;
    Method1.Code := @TESShot.HandleException;
    Application.OnException := TExceptionEvent(Method1);
  end;
end;

procedure TESShot.SetActive(value: Boolean);
var
  Method1: TMethod;
begin
  if csDesigning in TComponent(Owner).ComponentState then
    Exit;

  if FActive = value then
    Exit;

  FActive := value;
  if FActive then
  begin
    Method1.Data := Self;
    Method1.Code := @TESShot.HandleException;
    FOldOnException := Application.OnException;
    Application.OnException := TExceptionEvent(Method1);
  end
  else
  begin
    Application.OnException := FOldOnException;
    FOldOnException := nil;
  end;
end;

procedure TESShot.HandleException(Sender: TObject; E: Exception);
var
  Msg: string;
  aMethod: TMethod;
begin
  if FActive then
  try
    // oT
    Msg := E.Message;
    // Ts
    if (Screen.ActiveForm <> nil) and (Sender <> nil) then
      SaveErrorMessage(Screen.ActiveForm.Name, TComponent(Sender).Name, Msg)
    else if (Screen.ActiveForm = nil) and (Sender <> nil) then
      SaveErrorMessage('', TComponent(Sender).Name, Msg)
    else
      SaveErrorMessage('', '', Msg);

    // ۰ʦsù
    // Wsùƥ
    aMethod.Data := self;
    aMethod.Code := @TESShot.SaveErrorScreen;
    Application.OnIdle := TIdleEvent(aMethod);

    bGotData := False;
    // qXT
    MessageDlg(Msg, mtError, [mbOK], E.HelpContext);

    // sùƥ
    Application.OnIdle := nil;
  except
    MessageDlg(Msg, mtError, [mbOK], E.HelpContext);
  end
  else
    MessageDlg(E.Message, mtError, [mbOK], E.HelpContext);

  // ^즳 Application.OnException
  if Assigned(FOldOnException) then FOldOnException(Sender, E);
end;

procedure TESShot.SaveErrorMessage(FormName, ControlName, Msg: string);
var
  F: TextFile;
  S, Path: string;
begin
  try
    Path := ExtractFilePath(Application.EXEName);
    if (Path <> '') and (Path[Length(Path)] <> '\') then
      Path := Path + '\';
    AssignFile(F, Path + 'ER' + FormatDateTime('yyyymm', Date) + '.LOG');
{$I-}
    Append(F);
{$I+}
    if ioresult <> 0 then
      ReWrite(F);
    Msg := StrTran(Msg, #13, ' ');
    Msg := StrTran(Msg, #10, ' ');
    Msg := StrTran(Msg, #08, ' ');
    S := FormatDateTime('yyyy/mm/dd hh:nn:ss : ', Now);
    sNow := FormatDateTime('yyyymmddhhnnss', Now);
    if FormName <> '' then
      S := S + '[' + FormName + '] ';
    if ControlName <> '' then
      S := S + '[' + ControlName + '] ';
    WriteLn(F, S + Msg);
  finally
    CloseFile(F);
  end;
end;                                    {SaveErrorMessage}

procedure TESShot.SaveErrorScreen(Sender: TObject; var Done: Boolean);
var
  ScreenDC, hBitmap, BitmapDC: Integer;
  BitMap: TBitMap;
  JPEG: TJPEGImage;
  Path: string;
begin
  if bGotData then
    Exit;
  ScreenDC := CreateDC('DISPLAY', '', nil, nil);
  BitmapDC := CreateCompatibleDC(ScreenDC);
  hBitmap := CreateCompatibleBitmap(ScreenDC, Screen.Width, Screen.Height);
  BitMap := TBitMap.Create;
  JPEG := TJPEGImage.Create;
  try
    SelectObject(BitmapDC, hBitmap);
    if BitBlt(BitmapDC, 0, 0, Screen.Width, Screen.Height, ScreenDC, 0, 0, SRCCOPY) then
    begin
      BitMap.Handle := hBitmap;
      JPEG.CompressionQuality := 75;
      JPEG.Grayscale := True;
      JPEG.Performance := jpBestSpeed;
      JPEG.PixelFormat := jf8Bit;
      BitMap.Dormant;
      JPEG.Assign(BitMap);
      Path := ExtractFilePath(Application.EXEName);
      if (Path <> '') and (Path[Length(Path)] <> '\') then
        Path := Path + '\';
      TGraphic(JPEG).SaveToFile(Path + 'ER' + sNow + '.JPG');
      bGotData := True;
    end;
  finally
    BitMap.Free;
    JPEG.Free;
    DeleteDC(ScreenDC);
    DeleteDC(BitMapDC);
    DeleteObject(hBitmap);
  end;
end;                                    {SaveErrorScreen}

procedure TESShot.DeleteErrorScreen(Count: Integer);
var
  SearchRec: TSearchRec;
  FileName: TStringList;
  i: Integer;
  Path: string;
begin
  if Count <= 0 then
    Exit;
  FileName := TStringList.Create;
  FileName.Sorted := True;
  Path := ExtractFilePath(Application.EXEName);
  if (Path <> '') and (Path[Length(Path)] <> '\') then
    Path := Path + '\';
  if FindFirst(Path + 'ER*.JPG', faAnyfile, SearchRec) = 0 then
    repeat
      FileName.Add(SearchRec.Name);
    until FindNext(SearchRec) <> 0;
  SysUtils.FindClose(SearchRec);

  try
    if FileName.Count > Count then
    begin
      for i := 0 to FileName.Count - Count - 1 do
        DeleteFile(pchar(Path + FileName.Strings[i]));
    end;
  finally
    FileName.Free;
  end;
end;                                    {DeleteErrorScreen}

procedure TESShot.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  //if Operation = opInsert then
  //  init;
end;

function TESShot.StrTran(s1, s2, s3: string): string;
var
  Len1, Len2, p: Integer;
  s4: string;
begin
  Len1 := Length(s1);
  Len2 := Length(s2);
  s4 := '';
  p := 1;
  while p <= Len1 do
  begin
    if Copy(s1, p, Len2) = s2 then
    begin
      s4 := s4 + s3;
      p := p + Len2;
    end
    else
    begin
      s4 := s4 + Copy(s1, p, 1);
      p := p + 1;
    end;
  end;
  Result := s4;
end;                                    {strtran}

end.
